package com.eactive.eai.batch.job.jobItem.ked;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KEDBT_0300 extends DefaultTelegram implements TelegramService
{

    private int     SEQUENCE_NO;
    private int     SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int     REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private int     MISSING_COUNT;     //결번갯수
    private String  MISSING_FIELD;

    private Properties telegramInfo;
    private FileOutputStream fout;

    /**
     * 생성자
     */
    public SEND_KEDBT_0300() {
        //결번확인통보
        MISSING_COUNT = 0;
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            SEQUENCE_NO = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            boolean result = calculateMissingCount();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션ID - KED 및 회원사에서 업무구분을 위하여 SET하는 문자이다.
             // 회원사에서 KED에 파일 송신시 : “CB02"
            // KED에서 회원사에 파일 송신시 : “RB02"
            compileField(1, telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE), this.al_FieldProps[1]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(2, this.getFldTelegramType(), this.al_FieldProps[2]);

            //응답코드 - 전문의 처리결과를 나타내는 코드로 REQUEST전문(지시 및 요구전문)에는 “000”을 SET하며 RESPONSE전문(통보 및 보고전문)에서는 해당내용을 SET한다.
            compileField(3, this.getResolveResponseCode(), this.al_FieldProps[3]);

            //회원사 코드 - 전문을 전송한 기관을 확인하기 위한 회원사 코드 이다.
            compileField(4, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[4]);

            //파일명 - 0600/0610/0800/0810 전문의 경우 Space 처리함
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //전문전송 일시 - 전문을 발신하는 회원사에서 전문을 전송하는 일자와 시간을 SET 한다.
            compileField(6, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[6]);

            //BLOCK-NO
            compileField(7, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum(), this.al_FieldProps[7]);

            //SEQUENCE-NO
            compileField(8, ""+SEQUENCE_NO, this.al_FieldProps[8]);

            //결번갯수
            compileField(9, MISSING_FIELD, this.al_FieldProps[9]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            // 20060413 add by khs
            if (MISSING_COUNT==0) {
                fout.close();
                int block_no = batchDoc.getBatchMsg().getBody().getBlockNum();
                batchDoc.getBatchMsg().getBody().setBlockNum(block_no + 1);
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<6; i++) { //KED전문의 헤더는 파일명까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=6; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        int telegramSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
        int preFldTotSize = 0;
        for (int i=1; i< idx; i++) {
            byte[] aField = (byte[]) this.al_Field.get(i);
            preFldTotSize += aField.length;
        }

        return telegramSize - preFldTotSize;

    }
    public int getInformalFieldSendData(int idx, byte[] data) {
        int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
            	logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            for (int inx = 0; inx < fldLen; inx++) {
                data[inx] = ' ';
            }
            return fldLen;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            // KED 모든 전문은 길이가 4000바이트로 고정되어 있으며 이를 SequenceSize 로 지정하기로 한다.
            SEND_LENGTH = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            // X.25 이므로 아데나 장비용 길이 바이트를 추가
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

        return true;
    }

    private boolean calculateMissingCount () {
        try {

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
//            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();
            int block_size = this.batchDoc.getBatchMsg().getHeader().getBlockSize();

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            byte[] _missingNm = new byte[block_size];
            for (int i=0; i<block_size; i++) {
                _missingNm[i] = ' ';    //일단 공백으로 초기화
            }

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            if (block_data == null ){
                MISSING_COUNT = SEQUENCE_NO;
                for (int i = 0; i<SEQUENCE_NO; i++)
                    _missingNm[i] = '0';    //받은 DATA없을 시
            }else{
                for (int i = 0; i < SEQUENCE_NO; i++) {        //받은 seq_no만큼만 데이터 확인
                    byte[] data = (byte[]) block_data.get( new Integer(i) );
                    if (data != null ) {
                        _missingNm[i] = '1'; //정상이면 '1' 설정
                    }else{
                        _missingNm[i] = '0'; //결번이면 '0' 설정
                        MISSING_COUNT++;
                        logger.info("{} calculateMissingCount >> missing telegram : [" + i + "]", logHeader);
                    }
                }
            }

            if (MISSING_COUNT == 0) {
                if (!createFile()) {
                    return false;
                }
                
                int dataOffset = 0;
                try {
					dataOffset = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.KED_DATA_OFFSET));
				} catch (Exception e) {
					logger.info( e.getMessage(), e);
				}

                for (int i = 0; i < SEQUENCE_NO; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                    byte[] data = (byte[]) block_data.get(new Integer(i));
                    int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                    if ( recLen < 1 ){
                    	recLen = data.length;
                    }
                    byte[]layout = new byte[recLen];
                    for (int inx = 0; inx < layout.length; inx++) {
                        layout[inx] = ' ';
                    }

                    int dataCnt = data.length / recLen ;
                    for (int jnx = 0; jnx < dataCnt; jnx++) {
                        System.arraycopy( data,jnx*layout.length + dataOffset,layout,0,layout.length);
                        if ( !(new String(layout)).trim().equals("") ){
                            fout.write(layout);
                            fout.write( '\n' );
                            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
                        }
                    }

                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 Vector 초기화
            }

            this.MISSING_FIELD = new String (_missingNm);
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(MISSING_COUNT);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(MISSING_FIELD);

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            File file = new File(strFullPath);
            fout = new FileOutputStream(file, true);   //bytes will be written to the end of the file rather than the beginning
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//        return super.getFieldValueString(5);
//    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
//    //업무관리코드 필드값 리턴
//    public String getOpCode()
//    {
//        return super.getFieldValueString(10);
//    }
}

